//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  exchange bit strings
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "TBit.hpp"

void xchg(TBit& a,TBit& b)
{
  __asm {

    mov   esi,a
    mov   edi,b
#ifdef __BORLANDC__
    mov   eax,[esi.bit]
    xchg  eax,[edi.bit]
    mov   [esi.bit],eax

    mov   eax,[esi.size]
    xchg  eax,[edi.size]
    mov   [esi.size],eax

    mov   eax,[esi.nArray]
    xchg  eax,[edi.nArray]
    mov   [esi.nArray],eax
#else
    mov   eax,[esi+BIT]
    xchg  eax,[edi+BIT]
    mov   [esi+BIT],eax

    mov   eax,[esi]
    xchg  eax,[edi]
    mov   [esi],eax

    mov   eax,[esi+NARRAY]
    xchg  eax,[edi+NARRAY]
    mov   [esi+NARRAY],eax
#endif
  }
}
