//
//  Copyright (C) by S.Tomabechi 1997
//  All rights reserved.
//
//  compare real number to long integer
//
//  Fint  long>0 ̂ƂĂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"

int Fint::compareL(const long n) const
{
#ifdef _MEMMAN_DEBUG
check(__FILE__,__LINE__) ;
#endif
  signed char sign(1) ;
  __asm {
    mov   esi,this

    mov   ebx,n
    or    ebx,ebx                         // positive ?
    jge   POSITIVE
#ifdef __BORLANDC__
    cmp   dword ptr [esi.nDim],0        // positive ?
#else
    cmp   dword ptr [esi+NDIM],0
#endif
    jge   Great

    neg   ebx
    neg   sign
    jmp   COMP
  }
POSITIVE:                              // same signature
  __asm {
#ifdef __BORLANDC__
    cmp dword ptr [esi.nDim],0  // *this is positive  ?
#else
    cmp dword ptr [esi+NDIM],0
#endif
    jl  Less                    // negative
  }
COMP:
  __asm{
#ifdef __BORLANDC__
    mov   edi,[esi]
    mov   ecx,[esi.nDigit]   // #digits
    mov   eax,[esi.fDigit]
#else
    mov   edi,[esi]
    mov   ecx,[esi+NDIGIT]
    mov   eax,[esi+FDIGIT]
#endif
    inc   eax
    cmp   ecx,eax                      //  2ȏ̏ꍇ
    ja    Great
  }

  __asm {                              // *this=0 ?
    or    ecx,ecx
    jnz   nonZero
  }

  __asm {                              // *this=0 ̏ꍇ
    or    ebx,ebx                      // n is zero
    jnz   Less                         // n>0 this ̕
    jmp   Equal                        // n=0
  }
nonZero:                            // this is not Zero
  __asm {                           // ȉ 2s͂ȂĂ悢, 0 Ƃ̔r
                                    // 낤,Eo邽
    or    ebx,ebx                    // n is zero ?
    jz    Great                     // n  0  *this ͑傫
    cmp   ecx,eax                   // ax=_ȉ̌ + 1
    jl    Less
    mov   eax,[ecx*NBYTE+edi-NBYTE] // 
    cmp   eax,ebx                   // n 傫
    ja    Great                     // 傫
    jb    Less                      // 菬
    dec   ecx
    jz    Equal                     // ͂Ȃ
  }
more_Check:                         // ͂ЂƂ
  __asm {                           //  0 ׂ
    cmp   dword ptr [ecx*NBYTE+edi-NBYTE],0
    jne   Great                     // 0 łȂ
    dec   ecx
    jnz   more_Check
    jmp   Equal                     //  0 
  }
Less:
  __asm {
    neg   sign
    jmp   RET1
  }
Equal:
  __asm mov sign,0
Great:
RET1:
  return (int)sign ;
}

