//
//  Copyright (C) by S.Tomabechi 1995-1997
//  All rights reserved.
//
//  1995.01.17
//  ^ꂽfQőfł邩ǂׂ
//
//  1996.09.30
//    32rbg
//
//  1996.11.25
//    double large primes @ɑΉ
//
//  2000.08.05 c肪 2 (64 bit) ȉɂȂϋɓI rho @悤ɕύX
//

#ifdef __BORLANDC__
#pragma inline
#endif
#include "Mint.hpp"
//#include "LBit.hpp"

#include <math.h>
#include "Error.hpp"
struct PPrimes  {
  unsigned short diff ;        // 2
  char logP ;                  // 1
  char dmy ;                    // 1
  unsigned long Root ;         //  4  4 byte Kv
  unsigned long SievePos[2] ;  //  8  4 byte Kv
} ;

extern char SieveArray[] ;
extern unsigned long _OFF ;
extern unsigned long Pmax ;
extern unsigned long Lmax ;
extern unsigned long Pmax2[] ;
extern unsigned long Lmax2[] ;
extern Mint _fx ;
extern unsigned long _p1,_p2 ;
extern unsigned long Pmax4 ;

extern long _DivResult ;
extern int nLoop_rho ;
extern Mint const2 ;
extern Mint _d ;
extern Mint _xf ;
extern Mint _a1 ;
extern Mint _a2 ;

//  result:
//  _p1,_p2 : large primes
//
//  _DivResult: 0  fully factored
//              1  a large prime is remainded
//              2  2 large primes are remained
//             -1  remained part contains a very large prime
//
//

//  _p1,_p2 ꂸɎcf
//  ꂸɎcf̏ꍇ _p1=1 p2=prime ƂĕԂ
//
//  ߂l _DivResult: 0  fꂽ
//                     1  ꂸɎc͈̑f
//                     2  ꂸɎc͓̑f̐
//                     -1  ꂸɎcɑ傫ȑf
//
void DivideByBase(unsigned long SZR,PPrimes* Primes)
{
  long j ;
//  long nPrimes ;
  long Kr ;
  unsigned long c,ntry ;
  int nLoop ;
  unsigned long p ;
  unsigned long R_esi ;
  unsigned long R_edi ;
  unsigned long R_ecx ;
  unsigned long r1,r2 ;
  unsigned long Rhounit ;


Initialize:
  __asm {
    mov   dword ptr [_DivResult],-1     // initialize return value

#ifdef __BORLANDC__
    mov   ecx,dword ptr [_fx.nDigit]    // ȉ ecx ,q ̌ƂĎgp
    mov   esi,dword ptr [_fx]     // z̃AhX
#else
    mov   ecx,dword ptr [_fx+NDIGIT]
    mov   esi,dword ptr [_fx]
#endif
      lea  edi,[SieveArray]
      mov  eax,ecx
      rep  movsd                        // SieveArray ɃRs[

      mov  ecx,eax
      dec  ecx                          // -1

      mov esi,Primes
      lea esi,[esi+16]
      dec SZR
      mov edi,2                        // 
  }
MORE2:
  __asm {
      test dword ptr [SieveArray],1            // 2 Ŋ邩 ?
      jnz  Main_loop

      mov  ebx,ecx
#if 0
      xor  edx,edx
  }
DIV_2:
  __asm {
      mov  eax,dword ptr [SieveArray+ebx*NBYTE]
      div  edi
      mov  dword ptr [SieveArray+ebx*NBYTE],eax
      dec  ebx
      jns  DIV_2

      cmp dword ptr [SieveArray+ecx*NBYTE],0
      jnz  MORE2
      dec ecx
      jmp  MORE2                        //  2 Ŋ邩 ?
#else
      xor ecx,ecx
      mov eax,dword ptr [SieveArray]
    }
DIV2_LOOP:
    __asm {
      mov edx,eax
      inc ecx
      cmp ebx,ecx
      jb  DIV_END
      mov eax,dword ptr [SieveArray+ecx*NBYTE]
      shrd edx,eax,1
      mov dword ptr [SieveArray+ecx*NBYTE-4],edx
      jmp DIV2_LOOP
    }
DIV_END:
    __asm {
//     mov eax,[SieveArray+ecx*NBYTE-4]
      dec ecx
      shr edx,1
      mov dword ptr [SieveArray+ecx*NBYTE],edx
      or  edx,edx
      jnz MORE2
      dec ecx
      jmp MORE2
#endif
  }

Main_loop:
  __asm {
    dec   SZR
    js   pre_large_remainder            // All done
//    js    RET1               // f͐s,؂Ȃ

    lea esi,[esi+16]                      // incremnet index

    movzx eax,word ptr [esi]
    add   edi,eax
//    mov   edi,dword ptr Primes[esi*4]   // factor base ̑f

//xor edx,edx
//jmp Div1

//    lea   ebx,[esi*2+esi]               // SievePos ̃CfbNX

    xor   edx,edx                       // 邩ǂׂ
    mov   eax,[_OFF]                     // ́ASieve œꂽ
    sub   eax,[esi+8]                   //  SievePos  f p Ŋŏ̈ʒu
    div   edi
    or    edx,edx

#ifdef MPQS_DEBUG
jz  Div1
xor edx,edx
jmp Div1
#endif

    jz    Div2

    xor   edx,edx
    mov   eax,[_OFF]
    sub   eax,[esi+12]
    div   edi
    or    edx,edx

#ifdef MPQS_DEBUG
jz  Div1
xor edx,edx
jmp Div1
#endif

    jz    Div2

    jmp   Main_loop                     // ̑fł͊؂Ȃ

  }
Div1:
  __asm mov ebx,ecx                     // ۂɊƂ̂߂Ɍۑ
DivLoop1:                               // ؂邩ǂׂ
  __asm {
    mov   eax,dword ptr [SieveArray+ebx*NBYTE]
    div   edi                           // factor base ̑fŊĂ݂
    dec   ebx
    jns   DivLoop1

    or    edx,edx                       // ܂ 0 ?
#if 1
    jnz   Main_loop                     // Ȃ̂Ŏ̑fŎ
#else
    jz    Div2                          // divisible by factor base
    cmp  ecx,1                           // 2 digit ?
    ja   Main_loop                       // Ȃ̂Ŏ̑fŎ
    cmp  edi,Pmax4
    jb   Main_loop
    jmp  large_remainder

#endif
  }

Div2:                                   // ֗Ƃ edx=0
  __asm mov ebx,ecx
DivLoop2:                               // ؂̂ŎۂɊ
  __asm {
    mov   eax,dword ptr [SieveArray+ebx*NBYTE]
    div   edi
    mov   dword ptr [SieveArray+ebx*NBYTE],eax
    dec   ebx
    jns   DivLoop2


#ifdef MPQS_DEBUG1
or  edx,edx
jz  SUCCESS
lea   ebx,[esi*2+esi]

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,[esi+8]
div   edi

xor   edx,edx
mov   eax,dword ptr [_OFF]
sub   eax,[esi+12]
div   edi


jnz  RET2
#endif


  }
SUCCESS:
 __asm {
    cmp   dword ptr [SieveArray+ecx*NBYTE],0    // ŏʌ 0 ɂȂ ?
    jne   Div1
    dec   ecx                           // 炷
    jz    REDUCT_1                      // ꌅɂȂ
//    jnz   Div1                          // Ɋ邩

//    mov   ebx,esi                       // c͈ꌅɂȂ
    cmp   dword ptr [SieveArray+ecx*NBYTE],0    // ŏʌ 0 ɂȂ ?
    jne   Div1
    dec   ecx                           // 炷
    jnz   Div1                           // Ɋ邩
  }
REDUCT_1:                               // ꌅɂȂ
  __asm {
    mov   ebx,dword ptr [SieveArray]           // ebx Ɏcꌅu
    jmp   DivLoop12
  }

Main_loop20:
  __asm mov ebx,dword ptr [SieveArray]

Main_loop2:                             // c͈ꌅ
  __asm {
    dec   SZR
    js    RET1

//    inc   esi
    lea esi,[esi+16]

    movzx eax,word ptr [esi]
    add   edi,eax
//    mov   edi,Primes[esi*4]
  }
REDUCT:
  __asm {
    xor   edx,edx
  }
DivLoop12:                              // ؂邩ǂׂ
  __asm {
    mov   eax,ebx
    div   edi
  }
DIV_MORE:
  __asm {
    or    edx,edx
    jz    Set
    cmp   eax,edi                       // ͏菬 ?
    ja    Main_loop2
    jmp   Little
  }
Set:
  __asm {
    mov   ebx,eax
    div   edi
    jmp   DIV_MORE                           // ɊĂ݂
  }

Little:
  __asm {
                              // Factor Base ̑fƈv邩
                              // Factor Base 傫f(̐)
                              // Facto Base ̑f̐ςɂȂĂ邱Ƃ͂Ȃ.
    cmp   [Lmax],ebx // Large prime Ɣr
    jbe   RET1                   // Large prime ̂傫̂ NG
    cmp   ebx,[Pmax] // factor base ̍őfƔr
    ja    SetP                   // c͑傫 Large Prime 菬
    mov   dword ptr [_DivResult],0
    jmp   RET1

  }

check_more:                      // ւ͎̂c肪ꌅ̂Ƃ
__asm {
    cmp   ebx,[Lmax]   // greater than Large Prime ?
    ja    RET1                     // yes

  }
SetP:                            // (p) ^ ꂽ
  __asm {
    mov   [_p2],ebx
    mov   dword ptr [_p1],1
    mov   dword ptr [_DivResult],1  // gained (p) type
    jmp   RET1
  }



Trial:
  __asm {
//   xor edx,edx
     mov eax,dword ptr [SieveArray+NBYTE]
     div edi
     mov ecx,eax
     mov eax,dword ptr [SieveArray]
     div edi
     or  edx,edx
     jz  success
  }
NEXT_PRM:
  __asm {
     dec SZR
//   js  RET1
     js large_remainder

     lea  esi,[esi+16]
     movzx edx,word ptr [esi]
     add   edi,edx                                 // edi <= prime of FB

    xor   edx,edx                       // 邩ǂׂ
    mov   eax,[_OFF]
    sub   eax,[esi+8]                   //  SievePos[0]
    div   edi                               // ŏ̈ʒu
    or    edx,edx                           // ́ASieve œꂽ

    jz    Trial

    xor   edx,edx
    mov   eax,[_OFF]
    sub   eax,[esi+12]
    div   edi
    or    edx,edx
    jz    Trial

     jmp   NEXT_PRM

  }
success:
  __asm {
     mov dword ptr [SieveArray],eax
     or ecx,ecx                         // ͏Bc͈ꌅ
     jz  Main_loop20
     mov dword ptr [SieveArray+NBYTE],ecx
     jmp Trial
    }


TEST_PRM:
  __asm {
    mov   ecx,2
    mov   ebx,dword ptr [SieveArray]
    mov   eax,dword ptr [SieveArray+NBYTE]
    mov   edx,ebx
    and   edx,7                           // mod 8
    mov   edx,[_Kr_tab+edx*4]   // ] (2/_fx) vZ
    mov   Kr,edx
#ifdef __BORLANDC__
    mov   dword ptr [_xf.nDigit],ecx
    mov   byte ptr [_xf.nDim+3],1
    mov   esi,dword ptr [_xf]
#else
    mov   dword ptr [_xf+NDIGIT],ecx
    mov   byte ptr [_xf+SIGN],1
    mov   esi,dword ptr [_xf]
#endif
    mov   [esi],ebx
    mov   [esi+NBYTE],eax

    cmp  eax,[Lmax2+NBYTE]
//  ja   RETRY                               // ܂ factor base Ŋ邩Ȃ
    ja   RET1                             // ̏ꍇ͂ԂAlarge prime ȏ̑f
                                          // ܂܂Ă\̂ŁÂĂ

    jb   Criterion
    cmp  ebx,[Lmax2]
    ja  RET1                            // Ԃ,large prime ȏ̑f̐
  }
Criterion:
                              // EulerKAf炵͕݂̂Ȃ
  if( long(_d.apower(const2,(Mint::_Mtemp.isSubUL(_xf,1UL))>>=1,_xf))==Kr ) {
//goto RETRY;
    goto RET3 ;          // probably large prime
  }
  __asm {
    jmp RHO
  }

RETRY:
    __asm {

      cmp SZR,0               // Ō܂Ŏ肵 ?
      jl  RET1
      mov ecx,R_ecx           // WX^߂
      mov edi,R_edi
      mov esi,R_esi
      xor edx,edx
      cmp dword ptr [SieveArray+NBYTE],edx
      jne NEXT_PRM

      dec ecx
      jmp Main_loop20
    }


pre_large_remainder:
  __asm {
    cmp ecx,1
    jne RET1
  }
large_remainder:
  __asm {
                   // WX^̑Ҕ
    mov R_ecx,ecx  // 
    mov R_edi,edi  // f
    mov R_esi,esi  // index


    inc   ecx
  }


large_remainder_1:
  __asm {
    mov   eax,dword ptr [SieveArray+NBYTE]
    mov   ebx,dword ptr [SieveArray]
  }

OK:
  __asm {
//    mov   ebx,dword ptr [SieveArray]
    mov   edx,ebx
    and   edx,7                           // mod 8
    mov   edx,[_Kr_tab+edx*4]    // Jacobi symbol (2/_fx)
    mov   Kr,edx
#ifdef __BORLANDC__
    mov   dword ptr [_xf.nDigit],ecx
    mov   byte ptr [_xf.nDim+3],1
    mov   esi,dword ptr [_xf]
#else
    mov   dword ptr [_xf+NDIGIT],ecx
    mov   byte ptr [_xf+SIGN],1
    mov   esi,dword ptr [_xf]
#endif
    mov   dword ptr [esi],ebx
    mov   dword ptr [esi+NBYTE],eax
  }


  if( long(_d.apower(const2,(Mint::_Mtemp.isSubUL(_xf,1UL))>>=1,_xf))==Kr )
    goto RET3 ;

RHO:
  __asm {
        mov c,-1
//      mov Rhounit,50
        mov Rhounit,100
  }
TRY_MORE_1:
  __asm {

        mov ntry,5
        inc c
        inc c
        cmp c,5            // c=1,3,5 ɂ x^2+c  \rho @
#if 0
        ja  PRM_DIV
#else
        ja RETRY
#endif
    }
//  _a1.nDigit=1 ;
//  *_a1.digit=6 ;
//  _a2.nDigit=1 ;
//  *_a2.digit=37 ;

//    ntry=5 ;
TRY_MORE0:
    __asm {

      mov eax,ntry
      inc eax
      cmp eax,10
//    ja  PRM_DIV
      ja  TRY_MORE_1
      mov ntry,eax


//    add eax,6
      lea esi,[_a1]
      mov dword ptr [esi.nDigit],1
      mov esi,[esi]
      mov [esi],eax

      lea esi,[_a2]
      mov dword ptr [esi.nDigit],1
      mov esi,[esi]
      mul eax
//    inc eax
      add eax,c
      mov [esi],eax

      mov eax,[nLoop_rho]
      mov nLoop,eax


      mov eax,Rhounit
      cmp eax,20
      jb TRY_MORE
      shr eax,1
      mov Rhounit,eax
   }
//   _a2=(_a1*_a1+1)
//  (*_a1.digit)++ ;
TRY_MORE:
  __asm {
    lea esi,[_d]
    xor eax,eax
    inc eax
#ifdef __BORLANDC__
    mov [esi.nDigit],eax
    mov esi,[esi]
#else
    mov dword ptr [esi+NDIGIT],eax
    mov esi,[esi+DIGIT]
#endif
    mov [esi],eax
    cmp nLoop,eax
    jl  TRY_MORE_1
    mov ebx,Rhounit
    mov j,ebx
  }
RHO_LOOP:

      _d*=Mint::_Mtemp.isSub(_a2,_a1) ;
      _d.isRem(_d,_xf) ;
                          // ++ 邱ƂɂĂӂ\D
                          // ̏ꍇ͈Ӑ}錋ʂȂmȂ
                          // D
      Mint::_Mtemp.isMul(_a1,_a1) ;      // _a1*a+11
//    ++(*(Mint::_Mtemp.isMul(_a1,_a1)).digit) ;      // _a1*a+11
#ifndef __BORLANDC__
  #ifdef WIN32
     Mint::_Mtemp+=c ;
  #endif
#else
      __asm {
          mov   esi,dword ptr [@Mint@_Mtemp]
          mov   ebx,c
          add   [esi],ebx
          adc   dword ptr [esi+NBYTE],0
      }
#endif

      _a1.isRem(Mint::_Mtemp,_xf) ;                 // _a1=(_a1*_a1+1)%N

      Mint::_Mtemp.isMul(_a2,_a2) ;     // _a2*_a2+1
//    ++(*(Mint::_Mtemp.isMul(_a2,_a2)).digit) ;        // _a2*_a2+1
#ifndef __BORLANDC__
  #ifdef WIN32
     Mint::_Mtemp+=c ;
  #endif
#else
      __asm {
          mov   esi,dword ptr [@Mint@_Mtemp]
          mov   ebx,c
          add   [esi],ebx
          adc   dword ptr [esi+NBYTE],0
      }
#endif
      _a2.isMul(Mint::_Mtemp,Mint::_Mtemp) ; // (_a2*_a2+1)^2+1
//    ++(*(_a2.isMul(Mint::_Mtemp,Mint::_Mtemp)).digit) ; // (_a2*_a2+1)^2+1
#if 1
      __asm {
          mov   esi,dword ptr [_a2]
          mov   ebx,c
          add   [esi],ebx
          adc   dword ptr [esi+NBYTE],0
      }
#else
     _a2+=c ;
#endif
      _a2.isRem(_a2,_xf) ;

    __asm {
       dec  j              // <-> Rhounit
       jnz  RHO_LOOP
    }
    _d.isGCD(_d,_xf) ;



    __asm {
      dec nLoop
//    jz  RETRY                // łȂ
      mov edi,dword ptr [_d]      // d=1 ?
      cmp dword ptr [_d.nDigit],1       // d>2^32 ?
      jne EQUAL
      cmp dword ptr [edi],1
      je  TRY_MORE
      jmp FOUND
   }
EQUAL:
  __asm {
      mov eax,dword ptr [SieveArray+NBYTE]
      cmp eax,[edi+NBYTE]
      je  TRY_MORE0

    }

    _d=_xf/_d ;             // _d is greater than 2^32. replace  _d by _xf/_d

FOUND:
  __asm {
//inc [rR]
#ifdef __BORLANDC__
    mov  edi,dword ptr [_d]
#else
    mov  edi,[_d+DIGIT]
#endif
    mov  ecx,[edi]
    xor  edx,edx
    mov  eax,dword ptr [SieveArray+NBYTE]
    div  ecx
    or   eax,eax
    jz   small_cofactor
                                       // FFP,FPP,FFFF ̏ꍇ ?
    cmp  ecx,[Pmax]
    ja RETRY
//    ja RET1                   // f factor base ȏȂ
                              // c̑f large prime ȏł낤
                              // v؂Ď̂Ă
    mov  dword ptr [SieveArray+NBYTE],eax
    mov  eax,dword ptr [SieveArray]
    div  ecx
    mov  dword ptr [SieveArray],eax
    jmp TEST_PRM
  }
small_cofactor:
    __asm {
    mov  eax,dword ptr [SieveArray]
    div  ecx                   // ꂽfŊ ]߂
    cmp  ecx,eax
    ja   SETPP                 // eax<=ecx ƂȂ悤בւ
    xchg ecx,eax
  }
SETPP:
  __asm {
    cmp  ecx,[Lmax]          // Large prime 傫
#if 1
    jbe GAIN_LP
    cmp  eax,[Pmax]
    jbe  small_prime
    jmp  RET1
//    ja RETRY
#else
    ja   RET2                      // 傫̂Ŏ̂Ă
#endif
  }
GAIN_LP:
  __asm {
    cmp  eax,[Pmax]
    jbe  small_prime

    cmp  SZR,0                  // Ō܂łĂΑfɊԈႢȂ
    js   LP2
  #if 0
    jmp  RETRY
  #else
    jmp  check_prime            //
  #endif

  }
small_prime:
  __asm {
    mov  dword ptr [SieveArray],ecx         // Pmax 菬̂Ŏɖ߂
    mov  dword ptr [SieveArray+NBYTE],0     // ԂAFP ^ɊԈႢȂƎvÔ
    jmp  RETRY
  }
LP2:
  __asm {
    mov  [_p1],eax
    mov  [_p2],ecx
    mov  dword ptr [_DivResult],2
    jmp   RET1
  }

check_prime:
  __asm {
    mov r1,eax
    mov r2,ecx
  }
  // Ôߑfǂ`FbN  ԂKvȂAɗ邱ƂȂ
  if( amod(power((unsigned long)2,(r2-1)>>1,r2),r2)!=_Kr_tab[r2&7] ) goto RETRY ;
  if( amod(power((unsigned long)2,(r1-1)>>1,r1),r1)!=_Kr_tab[r1&7] ) goto RETRY ;
  _p1 = r1 ;
  _p2 = r2 ;
  _DivResult=2 ;

RET3:
RET2:
//__asm or eax,eax


RET1: ;


}
