//
//  Copyright (C) by S.Tomabechi 1994,1996
//    All rights reserved.
//
//  return value 0-31  : non-zero bit position
//               -1     : when n=0
//
//  return k s.t.  2^k <= n < 2^(k+1)
//
//  ŏʃrbgŉʃrbgXL 0 łȂŏ̃rbg
//  ̈ʒuԂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

long BitScanReverse(const unsigned long n)
{
  __asm {
    bsr   eax,n
    jnz   FOUND                 // ZF on if n=0
    mov   eax,-1                // in case n=0
  }
FOUND:
#ifdef __BORLANDC__
  return _EAX ;
#else
  __asm  mov n,eax
  return n ;
#endif
}

