//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  hyperbolic sine and hyperbolic cosine
//

#include "Fint.hpp"

Fint sinh(const Fint& x)
{
  Fint ex=exp(x) ;
  return (ex-1/ex)/2 ;
}

Fint cosh(const Fint& x)
{
  Fint ex=exp(x) ;
  return (ex+1/ex)/2 ;
}
