//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  assign real number by double
//
//  _̑
//
#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "LDbl.hpp"

Mint& Mint::operator=(const long double& d)
{
  LDbl D(d) ;
  signed char sign ;

     // add case d=0 1995.05.11
  if( D.isZero() ) {
    nDigit=0 ;
    nDim&=_POSITIVE_ ;
    return *this ;
  }

#ifdef __BORLANDC__
  if( nDigit<2 ) allocate(2) ;
  nDigit=2 ;
  sign=(signed char)D.Sign() ;
  (nDim&=_DIGITS_)|=((unsigned long)sign)<<24  ;
  digit[1]=D.High() ;                  // set significant digits
  digit[0]=D.Low() ;
  return (*this)<<=(D.Exp()-63) ;      // shift by power
#else
  if( nDigit<3 ) allocate(3) ;
  nDigit=3 ;
  sign=(signed char)D.Sign() ;
  (nDim&=_DIGITS_)|=((unsigned long)sign)<<24  ;
  digit[2]=1 ;
  digit[1]=D.High() ;
  digit[0]=D.Low() ;
  return (*this)<<=(D.Exp()-64) ;
#endif

}
