//
//	ؓcAq p115 
#include "Mint.hpp"
#include "Fint.hpp"
#include <vector.h>

using namespace std ;


void contfra3(int n,Mint* q)
{
  Mint p2,q2,p1,q1,p0,q0 ;
  int j ;
  p1=q[0] ; q1=1 ; p0=1 ; q0=0 ;
  for( j=1 ; j<n ; j++ ) {
	p2=q[j]*p1+p0 ;
	q2=q[j]*q1+q0 ;
	p0=p1 ;
	p1=p2 ;
	q0=q1 ;
	q1=q2 ;

  }
}


//[q0,q1,q2,....]

// return [q0,q1]
void contfra3_init(vector<Mint>& q,Mint& p0,Mint& q0,Mint& p1,Mint& q1,unsigned long& count)
{
	p1=q[0] ; 
	q1=1 ;
	p0=1 ;
	q0=0 ;	
	count=0 ;
}

// next [q0,q1,...,qk,q_(k+1)]
bool contfra3_next(vector<Mint>& q,Mint& p0,Mint& q0,Mint& p1,Mint& q1,unsigned long& count)
{
	Mint p2,q2 ;
	count++ ;
	if( count>=q.size() ) return false ;
	p2=q[count]*p1+p0 ;
	q2=q[count]*q1+q0 ;
	p0=p1 ;
	p1=p2 ;
	q0=q1 ;
	q1=q2 ;
	return true ;
	
}
