//
//  Copyright (C) by S.Tomabechi 1993,1996 Ver 1.2
//  All rithts reserved.
//
//  Stop Watch
//  Ԃv
//
//  1996/10 Windows95 pɏC. (X DOS p)
//
//  [usage]
//    CPUTime cputime ;
//    cputime.Start() ;
//       do something ;
//    cputime.Stop() ;
//    cputime.Start() ;
//       do other thing ;
//    cputime.Stop() ;     increase duration time
//                         pԂ͉ZD
//    cputime.Reset() ;    set duration time 0
//                         pԂ 0 ɂ
//
#ifndef __CPUTIME_HPP
#define __CPUTIME_HPP

#include <iostream.h>
#include <time.h>
#ifndef __BORLANDC__
    #ifndef WIN32
    inline long GetTickCount() { return time(NULL)*1000 ; }
    #endif
#endif

class CPUTime
{
  friend ::istream& operator>>(::istream& is,CPUTime& cputime) ;
public:
  CPUTime(void) { Duration=0 ; }
  void Start(void) ;
  void Stop(void)  ;
  void Reset(void) { Duration=0 ; }
  double Time() { return Duration/1000 ; }
  unsigned long hour(void) { return (unsigned long)(Time()/3600) ; }
  unsigned long second(void) { return (unsigned long)(Time()-(unsigned long)(Time()/60)*60) ; }
  unsigned long minutes(void) { return (unsigned long)(Time()-hour()*3600)/60 ; }
  unsigned long hundredths(void) { return (unsigned long)(100*(Time()-(unsigned long)(Time()))) ; }
private:
  double StartTime ;            // start time
                                // X^[g
  double Duration ;             // duration time
                                // p
} ;

::ostream& operator<<(::ostream& os,CPUTime& cputime) ;
::istream& operator>>(::istream& is,CPUTime& cputime) ;
#endif
