//
//	Copyright (C) by S.Tomabechi 2001
//	All rights reserved.
//
//	Sieve Part of SIQS method
//

#ifdef __BORLANDC__
#pragma inline
#endif

#define _ONLY_MINTDECL_
#include "Mint.hpp"
#include "PPMPQS.hpp"
#include "IntFuncs.hpp"
//extern unsigned long _A[] ;
//extern unsigned long _B[] ;
//extern unsigned long nSieveResult ;
//extern unsigned long SieveResult[] ;
//extern Mint _a ;
//extern Mint _b ;
//extern unsigned long SieveUnit ;
//extern unsigned long SieveWidth ;
//extern unsigned long SieveWidth2 ;
//extern char Cutoff ;
//extern const unsigned long MaxSieveResult ;
//extern Mint pN ;

//extern char SieveArray[] ;
extern char lg1[] ;
extern unsigned long ip[] ;
extern unsigned long pq[] ;
extern Mint B[] ;


//extern long _nResult ;		// number of cancidates which seem to be smooth


//
// recover parameters (logP)
//
void SieveDone(unsigned long ncomb,PPrimes* Primes) {
	__asm {
		mov ecx,ncomb
		mov esi,Primes
		dec ecx
	}
MAIN_LOOP:
	__asm {
		mov al,[lg1+ecx]			// recover logP
		mov ebx,[ip+4*ecx]			// index to prime
		lea ebx,[ebx*4+ebx]			// ebx <- 5*ebx
		mov [esi+4*ebx+2],al		// Primes[].logP
		mov [esi+4*ebx+3],al		// recover flag
		dec ecx
		jns MAIN_LOOP
	}
}
