//
//  Copyright (C) by S.Tomabechi 1995,1996,1997,1999
//  All rights reserved.
//
//  ^ꂽȑfQőf,̙pw 2 @ƂĕԂ.
//  PPMPQS@Ŏgp
//
//  1999/12/12  c肪ꌅɂȂƂA؂f binary search ŒT悤ɕύX
//
//  ߂l
//     true  : ł
//     false : łȂ
//
//  ӁAfactor base Ɋւ smooth ł邱
//        large prime ΂ŊĂ
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "Mint.hpp"

#include <math.h>
extern unsigned long Primes[] ;

extern unsigned long v2[] ;
extern unsigned long Upper0 ;
extern unsigned long Upper1 ;
extern Mint Upper2 ;

bool BitDecomp(long nPrimes,Mint& q)
{
  bool result(true) ;
  long j(0) ;
  unsigned long p(0) ;

  __asm {
    mov   ebx,dword ptr [nPrimes]   // number of factor base
    add   ebx,31
    shr   ebx,5                     //  1/32
  }
clear:                              // rbgNA (4byteÂ)
  __asm {
    xor   eax,eax
    mov   ecx,ebx
    lea   edi,v2
    rep   stosd
  }
  __asm {
#ifdef __BORLANDC__
    mov   esi,q
    cmp   dword ptr [esi].nDim,0         // q is negative ?
    jge   Initialize
    neg   byte ptr [esi].nDim[3]
    bts   dword ptr [v2],0               // 0 rbgڂ I ɂ
#else
    mov   esi,q
    cmp   dword ptr [esi+NDIM],0       // q is negative ?
    jge   Initialize
    neg   byte ptr [esi+SIGN]
    bts   dword ptr [v2],0                    // 0 rbgڂ I ɂ
#endif
  }


Initialize:
  __asm {
#ifdef __BORLANDC__
    mov   ecx,dword ptr [esi.nDigit]   // ȉ ecx ,q ̌ƂĎgp
    mov   esi,[esi]
    xor   edi,edi
#else
    mov   ecx,dword ptr [esi+NDIGIT]   // ȉ ecx ,q ̌ƂĎgp
    mov   esi,[esi]
    xor   edi,edi
#endif
    dec   ecx
    jz    Main_loop20                   // łɈꌅ
  }
Main_loop:
  __asm {
    dec   nPrimes
    jz    large_remainder

    inc   j                             // increase index

    mov   ebx,j
  }

  __asm {

    mov   eax,dword ptr Primes[ebx*4]

    mov   p,eax                         // p is a prime of factor base
    xor   edx,edx
  }
Div1:
  __asm mov ebx,ecx              // ۂɊƂ̂߂Ɍۑ
DivLoop1:                        // ؂邩ǂׂ
  __asm {
    mov   eax,dword ptr [ebx*NBYTE+esi]
    div   p                      // factor base ̑fŊĂ݂
    dec   ebx
    jns   DivLoop1

    or   edx,edx                 // ] 0 ?
    jz   Div2                    // ۂɊďɒu
 }
  __asm {
//    or    edi,edi
//    jz    Main_loop              // Ȃ
//  test  edi,1                  //  ?
//  mov   edi,0                  // tOωȂ
    and   edi,1
    jz    Main_loop              // 
  }
  __asm {                        // 񊄂ꂽ
    mov   ebx,j
    mov   edx,ebx
    shr   ebx,5                  //  j/32
    and   edx,0000001fh          //  j%32

    bts   dword ptr v2[ebx*4],edx

    xor  edi,edi                 // edi <- 0
    jmp  Main_loop
  }
Div2:                            // ֗Ƃ edx=0
  __asm mov ebx,ecx
DivLoop2:                        // ؂̂ŎۂɊ
  __asm {
    mov   eax,dword ptr [ebx*NBYTE+esi]
    div   p
    mov   dword ptr [ebx*NBYTE+esi],eax
    dec   ebx
    jns   DivLoop2

    inc edi

    cmp   dword ptr [ecx*NBYTE+esi],0  // ŏʌ 0 ɂȂ ?
    jnz   Div1
    dec   ecx                    // 炷
    jz   REDUCT_1                // c͈ꌅ

    cmp   dword ptr [ecx*NBYTE+esi],0  // ŏʌ 0 ɂȂ ?
    jnz   Div1
    dec   ecx                    // 炷
    jnz   Div1
  }
REDUCT_1:
  __asm {
    mov   ebx,j                  // ebx <- index
    jmp DivLoop12
  }

Main_loop20:                     // c͈ꌅ
  __asm mov ebx,j
Main_loop2:
  __asm {
    dec   nPrimes
    jz    large_remainder        // ؂Ȃ񕪉𕔕𒲂ׂ
                                 //  Upper1 傫ȑfŎ̂ĂĂ悢
    inc   ebx

    mov   eax,dword ptr Primes[ebx*4]  // ̑f
    mov   p,eax                       // p ͑f
  }
REDUCT:
  __asm {
    xor   edx,edx                // Z̏
  }
DivLoop12:                       // ؂邩ǂׂ
  __asm {
    mov   eax,dword ptr [esi]
    div   p
    or    edx,edx
    jnz   SetBit
    mov   dword ptr [esi],eax
    inc   edi                    // ꂽ񐔂𑝂₷
    jmp   DivLoop12              // ɊĂ݂
  }
SetBit:
  __asm {
    or    edi,edi
    jz    Little                 // Ȃ
//  test  edi,1                  //  ?
//  mov   edi,0
    and   edi,1                  // check parity
    jz    remainder_1            // 񊄂ꂽ
  }
  __asm {                        // 񊄂ꂽ
    mov   eax,ebx
    mov   edx,eax
    shr   eax,5                  //  j/32
    and   edx,0000001fh          //  j%32

    bts   dword ptr v2[eax*4],edx   // fɑΉʒũrbgIɂ
    xor   edi,edi                // clear parity

  }
remainder_1:
  __asm {
    cmp    dword ptr [esi],1  // factored by factorbase  ?
    jne    Main_loop2
    mov    result,1           // fully factored
    jmp    RET1
  }

Little:
  __asm {
    cmp   eax,p               // ͏菬
    jae   Main_loop2         // ł Factor Base ̑fƈv邩
                              // Factor Base 傫f(̐)
    mov   eax,dword ptr [esi] // RET9 ܂ eax ͌Œ
  }
/*****************
Search_Position:               ֗鎞,؂邩 (f)^,(p)^̏ꍇ
  __asm {                      񕪉𕔕f̂Ƃ낤
    dec   nPrimes              { binary search Ƃɂׂ낤
                               eNjbNȂ̂œD

    jz    SetPP                Factor Base 傫 Upper1 菬f

    inc   ebx
    mov   edx,dword ptr Primes[ebx*4] ;
    cmp   eax,edx              Factor Base ƈv邩

    jne   Search_Position
    mov   p,edx
    jmp   REDUCT               v̂.ۂɊĂ݂.
  }
*****************/


  // ֗鎞,؂邩 (f)^,(p)^̏ꍇ
  // vf̃CfbNXT
  //  binary search ɂTɕύX 1999.12.10
  __asm {
    mov  ecx,nPrimes
    add  ecx,ebx
//    cmp  eax,dword ptr Primes[ecx*4] // ̔r͂ȂĂǂ͂
//    ja   SetPP               // factor base ̑f傫
  }
Search_Position:
  __asm {
    mov  edx,ebx            // ebx < ecx
  }
Search_Position1:
  __asm {
    add  edx,ecx
    inc  edx
    shr  edx,1
    cmp  eax,dword ptr Primes[edx*4]
    ja   SET_ebx           // greater than a prime of factor base
    jb   SET_ecx           // less than a prime of factor base

    mov  ebx,edx           // same as a prime of factor base
    mov  edx,dword ptr Primes[edx*4]
    mov  p,edx
    jmp  REDUCT
  }
SET_ebx:
  __asm {
    mov ebx,edx          // search right half part
    jmp Search_Position1
  }
SET_ecx:
  __asm {
    mov ecx,edx          // search left half part
    jmp Search_Position
  }

check_more:
SetPP:
large_remainder:
  __asm {
    mov   result,0            // ؂Ȃ
  }

RET1:

  return result ;

}
