//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  logical product of bit strings 
//
#ifdef __BORLANDC__
#pragma inline
#endif

#include "TBit.hpp"

TBit& TBit::operator&=(const TBit& b)
{
  __asm {
    mov   esi,this
    mov   edi,b
#ifdef __BORLANDC__
    mov   edx,[esi.nArray]
    mov   ecx,[edi.nArray]
#else
    mov   edx,[esi+NARRAY]
    mov   ecx,[edi+NARRAY]
#endif
    cmp   edx,ecx
    jle   EXEC
    mov   edx,ecx
  }
EXEC:
  __asm {
    or    ecx,ecx
    jz    RET1
#ifdef __BORLANDC__
    mov   esi,[esi.bit]
    mov   edi,[edi.bit]
#else
    mov   esi,[esi+BIT]
    mov   edi,[edi+BIT]
#endif

  }
AND_LOOP:
  __asm {
    mov   eax,[ecx*BITBYTE+edi-BITBYTE]
    and   [ecx*BITBYTE+esi-BITBYTE],eax
    dec   ecx
    jnz   AND_LOOP
  }

RET1:
  return *this ;
}
