//
//  Copyright (C) by S.Tomabechi
//  All rights reserved.
//
//  logical sum of bit strings 
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "TBit.hpp"

TBit& TBit::operator|=(const TBit& b)
{
  __asm {
    mov   esi,this
    mov   edi,b
#ifdef __BORLANDC__
    mov ecx,[esi.nArray]
    mov edx,[edi.nArray]
#else
    mov ecx,[esi+NARRAY]
    mov edx,[edi+NARRAY]
#endif
    cmp   ecx,edx
    jle   EXEC
    mov   ecx,edx
  }
EXEC:
  __asm {
#ifdef __BORLANDC__
    mov   esi,[esi.bit]
    mov   edi,[edi.bit]
#else
    mov   esi,[esi+BIT]
    mov   edi,[edi+BIT]
#endif
  }
LOOP1:
  __asm {
    mov   eax,[ecx*BITBYTE+edi-BITBYTE]
    or    [ecx*BITBYTE+esi-BITBYTE],eax
    dec   ecx
    jnz   LOOP1
  }

  return *this ;
}
