//
//  Copyright (C) by S.Tomabechi 1994
//  All rights reserved.
//
//  logical exclusive or of bit strings
//
#ifdef __BORLANDC__
#pragma inline
#endif
#include "TBit.hpp"

TBit& TBit::operator^=(const TBit& b)
{
  __asm {
    mov   esi,this
    mov   edi,b
#ifdef __BORLANDC__
    mov ecx,[esi.nArray]               // length of bit string *this
    mov eax,[edi.nArray]               // length of bit string b
#else
    mov ecx,[esi+NARRAY]
    mov eax,[edi+NARRAY]
#endif
    cmp   ecx,eax
    jle   EXEC
    mov   ecx,eax
  }
EXEC:
  __asm {
    or  ecx,ecx
    jz  RET1
#ifdef __BORLANDC__
    mov   esi,[esi.bit]
    mov   edi,[edi.bit]
#else
    mov   esi,[esi+BIT]
    mov   edi,[edi+BIT]
#endif
  }
LOOP_XOR:
  __asm {
    mov   eax,[ecx*BITBYTE+edi-BITBYTE]
    xor   [ecx*BITBYTE+esi-BITBYTE],eax
    dec   ecx
    jnz   LOOP_XOR
  }
RET1:
  return *this ;
}
