//
//  Copyright (C) by S.Tomabechi 1995
//  All rights reseved.
//
//  pvZ
//
#include "Complex.hpp"

//
// n 𕡑fƂČvZƐx̂ŕʈ
//
//  n^c=n^re(c)*exp(i*log(n)*im(c))
//
Complex power(const Mint& n,const Complex& c)
{
  Fint t(real(c).fdigit()+1,real(c).fdigit()) ;
  t=n ;
  t=imag(c)*log(t) ;
  return power(n,real(c))*Complex(cos(t),sin(t)) ;
}

Complex power(const Complex& x,const Fint& y)
{
  if( sign(y)<0 ) return power(x,-y) ;
  Mint Ipart(Int(y)) ;               // ȂׂΐvZgȂ悤ɂ
//  return power(x,y-Ipart)*power(x,Ipart) ;
  return exp(log(x)*(y-Ipart))*power(x,Ipart)  ;
}


// 2000/07/18  n ̏ꍇ̏Ȃ
Complex power(const Complex& x,const Mint& n)
{
  Complex y(1) ;
  long leng=ilog2(n) ;
  unsigned long d ;
  int j(0),k ;
  if( sign(n)>=0 ) Complex::_Ctemp=x ;
  else Complex::_Ctemp=1/x ;

  if( leng>=0 ) for(;;) {         // n!=0
    d=n.digit[j++] ;
    for( k=32 ; k!=0 ; k-- ) {
      if( d&1 ) y*=Complex::_Ctemp ;
      if( --leng<0 ) goto RET1 ;
      d>>=1 ;
      Complex::_Ctemp*=Complex::_Ctemp ;
    }
  }
RET1:
  return y ;

}

Complex power(const Complex& x,unsigned long n)
{

  Complex y(1) ;
  Complex::_Ctemp=x ;

  if( n ) for(;;) {
    if( n&1 ) y*=Complex::_Ctemp ;
    if( (n>>=1)==0 ) break ;
    Complex::_Ctemp*=Complex::_Ctemp ;
  }
  return y ;

}

Complex power(const Complex& x,long n)
{
  if( n>=0 ) return power(x,(unsigned long)n) ;
  else       return power(1/x,(unsigned long)(-n)) ;

}
