//
//  Copyright (C) by S.Tomabechi 1993
//  All rights reserved.
//
//  calculate gamma function
//
//             /   s-1  -x
//  \gamma(s)= |  x    e  dx      Re(s)>0
//             /

#include "Fint.hpp"

Fint gammaln(const Fint& x) ;

Fint gamma(const Fint& x)
{
  Mint n=Int(x) ;
  if( sign(x)>0 && x==n ) {       // x ͐
    Fint gam(1) ;                // (s)=(s-1)!
    do {                         // KvZ
      gam*=n ;
      --n ;
    } while( n!=0 ) ;

#ifdef _MEMMAN
gam[x.fdigit()-gam.fdigit()] ;
gam.check(__FILE__,__LINE__) ;
return gam ;
#endif

    return gam[x.fdigit()-gam.fdigit()] ;
  }
             // Re(s) 傫ꍇ log((s)) vZ
  return exp(gammaln(x)) ;

}
