//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  greatest common divisor of long integers
//
#ifdef __BORLANDC__
#pragma inline
#endif

long gcd(const long a,const long b)
{
  __asm {

    mov eax,a
    or  eax,eax
    jge Positive1
    neg eax           // make a positive
  }
Positive1:
  __asm {
    mov ebx,b
    or  ebx,ebx
    jge LOOP1
    neg ebx           // make b positive
  }
LOOP1:
  __asm {
    or  ebx,ebx       // b==0 ?
    jz  RET1
    xor edx,edx
    div ebx            // r=a mod b
    mov eax,ebx        // a <- b
    mov ebx,edx        // b <- r   (b is replaced by residue)
    jmp LOOP1
  }
RET1:
#ifdef __BORLANDC__
  return _EAX ;
#else
  __asm mov a,eax
  return a ;
#endif
}

