//
//  Copyright (C) by S.Tomabechi 1994,1995
//  All rights reserved.
//
//  greatest common divisor of unsigned long integers
//
#ifdef __BORLANDC__
#pragma inline
#endif

unsigned long gcd(const unsigned long a,const unsigned long b)
{
  __asm {
    mov eax,a
    mov ebx,b
  }
MOD_LOOP:
  __asm {
    or  ebx,ebx        // b=0 ?
    jz  RET1
    xor edx,edx
    div ebx            // r=a mod b
    mov eax,ebx        // a <- b
    mov ebx,edx        // b <- r
    jmp MOD_LOOP
  }
RET1:
#ifdef __BORLANDC__
  return _EAX ;
#else  
  __asm mov a,eax
  return a ;
#endif  
}

