//
//  Copyright (C) 1993,1994,1995  by S.Tomabechi
//     All rights reserved
//
//   assignment   real <- integer
//
#ifdef __BORLANDC__
#pragma inline
#endif

#ifndef __cplusplus
#error Must use C++ for the type Fint
#endif

#define _ONLY_MINTDECL_
#define _ONLY_FINTDECL_
#include "Fint.hpp"


Fint& Fint::operator=(const Mint& a)
{
#ifdef _MEMMAN
a.check(__FILE__,__LINE__) ;
#endif
  int _size ;
  __asm {
    mov edi,this
    mov esi,a
#ifdef __BORLANDC__
    mov eax,[esi.nDigit]
    add eax,[edi.fDigit]
    mov _size,eax
    mov ebx,[edi.nDim]
#else
    mov eax,[esi+NDIGIT]
    add eax,[edi+FDIGIT]
    mov _size,eax
    mov ebx,[edi+NDIM]
#endif
    and ebx,_DIGITS_
    cmp eax,ebx
    jbe ASSIGN
  }

  allocate(_size) ;                    // enlarge array

  __asm {

    mov   edi,this
    mov   esi,a
  }
ASSIGN:
  __asm {
#ifdef __BORLANDC__
    cmp   dword ptr [esi.nDigit],0
    jne   MOVE
    mov   dword ptr [edi.nDigit],0    // a=0
    mov   byte ptr [edi.nDim+3],1
#else
    cmp   dword ptr [esi+NDIGIT],0
    jne   MOVE
    mov   dword ptr [edi+NDIGIT],0
    mov   byte ptr [edi+SIGN],1
#endif
    jmp   RET1
  }
MOVE:
  __asm {
#ifdef __BORLANDC__
    mov   eax,_size
    mov   [edi.nDigit],eax

    mov   al,[esi.nDim+3]
    mov   [edi.nDim+3],al

    mov   ecx,[edi.fDigit]
    mov   edx,[esi.nDigit]
    mov   eax,ecx

    mov   edi,[edi]
    mov   esi,[esi]
#else
    mov   eax,_size
    mov   [edi+NDIGIT],eax

    mov   al,[esi+SIGN]
    mov   [edi+SIGN],al

    mov   ecx,[edi+FDIGIT]
    mov   edx,[esi+NDIGIT]
    mov   eax,ecx

    mov   edi,[edi]
    mov   esi,[esi]
#endif
  }
Clear:
  __asm {                           // clear fractional part
    mov   dword ptr [ecx*NBYTE+edi-NBYTE],0
    dec   ecx
    jnz   Clear

    lea  edi,[edi+eax*NBYTE]
  }
Copy:
  __asm {                           // copy integer part
    mov   eax,[edx*NBYTE+esi-NBYTE]
    mov   [edx*NBYTE+edi-NBYTE],eax
    dec   edx
    jnz   Copy
  }
RET1:
#ifdef _MEMMAN
check(__FILE__,__LINE__) ;
#endif
  return *this ;
}
