//
//  Copyright (C) by S.Tomebechi 1994,1995
//  All rights reserved.
//
//  heap memory manager 
//  q|vǗNX
//
//  created at 1994/Jun
//
//
#ifndef __MEMMAN_HPP
#define __MEMMAN_HPP
#include <stdlib.h>
#include <iostream.h>
#include <iomanip.h>
#include "Error.hpp"


class MemMan ;
class MemBlock ;

class Mem                   // ubN long ̔zƂĂ݂邽߂
{                           // ev[g
  friend class MemMan ;
  friend class MemBlock ;
  Mem(){}
  long size ;               // o͂ꂾ
} ;

class MemBlock
{
  friend class MemMan ;
private:               // ׂ private
  MemBlock* pBlock ;   //  MemBlock w
  Mem* availMem ;      // 擪󂫗̈Tςނ悤󂫗̈
                       // ̂肻ȕt߂oĂ
                       // ۂ͍Ō allocate Ƃ
  Mem* pMem ;          // ubN̐擪AhX

  MemBlock(long BLOCK_SIZE)
  {
    pBlock=NULL ;
    pMem=new Mem[(BLOCK_SIZE+3)/4] ;
//    if( !pMem ) Error( allocate error ) ;
    pMem->size=(BLOCK_SIZE+3)/4-1 ;          // p\őTCY
    (pMem+(BLOCK_SIZE+3)/4-1)->size=0 ;      // I[
    availMem=pMem ;
  }
  ~MemBlock() { delete [] pMem ; }
  Mem* alloc(long nunits) ;
  void merge(void) ;
public:
  void debug(long BLOCK_SIZE) ;   // debug p֐
  long check(long BLOCK_SIZE) ;   // debug p
} ;



class MemMan                // U
{
  static unsigned long nalloc ;   // fobOp̕ϐ
  static unsigned long nfree ;
  static unsigned long nBlock ;

public:
  MemMan(long _size=0x00020000){
    BLOCK_SIZE=_size ;
    availBlock=NULL ;
    newBlock() ;
    availBlock->pBlock=availBlock ;
  }
  void* alloc(long nByte) ;  // 蓖Ă
  void free(void* p) ;

  void debug() ;      // debug p
  long check(char* file,int line) ;      // debug p

  ~MemMan() ;

private:

  MemBlock* availBlock ;
  long BLOCK_SIZE ;   // ubÑTCY

  void newBlock(void) ;

} ;

#endif


